if __name__ == '__main__':
    pass


import numpy as np
import matplotlib.pyplot as plt
import Three1 as HSVTools 


' Teilaufgabe a) '

def createHSHistogram(imgHSV):
    h, w = imgHSV.shape[0], imgHSV.shape[1]
    hist = np.zeros((360, 256))
    for y in xrange(h):
        for x in xrange(w):
            h = int(imgHSV[y, x, 0]*359)
            s = int(imgHSV[y, x, 1]*255)
            hist[h, s] += 1
    return hist
    
    
def aufgabe2a():
    img = plt.imread('nerds.png')
    imgHSV = HSVTools.RGBtoHSVImage(img)
    hist = createHSHistogram(imgHSV)   
    plt.figure(1)
    plt.subplot(121)
    plt.imshow(img)
    plt.subplot(122)
    plt.imshow(hist, cmap=plt.cm.gray)
    plt.show() 
    
    
    
' Teilaufgabe b) '


def backProjection(imgModel, imgInput):
    # i) Modellbild und Eingabebild im HSV-Format:
    imgModelHSV = HSVTools.RGBtoHSVImage(imgModel)
    imgInputHSV = HSVTools.RGBtoHSVImage(imgInput)
    
    # ii) Berechnung der HS-Histogramme:
    modelHist = createHSHistogram(imgModelHSV)
    inputHist = createHSHistogram(imgInputHSV)
     
    # iii) Berechnung des Verhaeltnishistogramms:
    r = np.zeros((360, 256))
    for y in xrange(360):
        for x in xrange(256):
            m = float(modelHist[y, x])
            i = float(inputHist[y, x])
            if i == 0 : r[y, x] = 1.0
            else : r[y, x] = min(1.0, m/i)
            
    # iv) Back-Projection der Pixel des Eingabebildes:
    return np.array([[ r[int(h*359), int(s*255)] for h, s, v in row] for row in imgInputHSV])


#Alternativ:
def backProjection2(imgModel, imgInput):
    # i) Modellbild und Eingabebild im HSV-Format:
    imgModelHSV = HSVTools.RGBtoHSVImage(imgModel)
    imgInputHSV = HSVTools.RGBtoHSVImage(imgInput)
    
    # ii) Berechnung der HS-Histogramme:
    modelHist = createHSHistogram(imgModelHSV)
    inputHist = createHSHistogram(imgInputHSV)
     
    # iii) Variante - im Vergleich zur ersten Implementierung oben "direktes Lookup":
    height, width = (imgInputHSV.shape[0], imgInputHSV.shape[1])
    result = np.zeros((height, width))
    for y in xrange(height):
        for x in xrange(width):  
            h = int(imgInputHSV[y, x, 0]*359)
            s = int(imgInputHSV[y, x, 1]*255)
            m = float(modelHist[h, s])
            i = float(inputHist[h, s])
            if i == 0 : result[y, x] = 1.0
            else : result[y, x] = min(m/i, 1.0)
    return result        
    
    
 
def aufgabe2b():
    imgModel = plt.imread('haut.png')
    imgInput = plt.imread('hand.png')
    imgBP = backProjection(imgModel, imgInput)
    plt.figure(1)
    plt.subplot(131)
    plt.imshow(imgModel)
    plt.subplot(132)
    plt.imshow(imgInput)
    plt.subplot(133)
    plt.imshow(imgBP, cmap=plt.cm.gray)
    plt.show() 



'''
Tests:
'''
    
' Tests ausfuehren (entsprechend ein-/ausklammern): '

aufgabe2a()
#aufgabe2b()