import numpy as np
import matplotlib.pyplot as plt
import Three1 as HSVTools
import math



' Teilaufgabe a) '


def computeAverageColor(img):
    r = np.mean(img[:,:,0])
    g = np.mean(img[:,:,1])
    b = np.mean(img[:,:,2])
    return r, g, b


def computeEuklidianDistance(p, q):
    return math.sqrt(math.pow(p[0]-q[0], 2) + 
                      math.pow(p[1]-q[1], 2) + 
                      math.pow(p[2]-q[2], 2))
    

def computeMaximumDistance(img, avg):
    m = 0
    for row in img :
        for px in row :
            m = max(m, computeEuklidianDistance(px, avg))
    return m



def euklidianDistanceSearch(imgModel, imgInput):
    # Durchschnittsfarbwert berechnen:
    avg = computeAverageColor(imgModel)
    # maximale Distanz zu diesem Durchschnitt berechnen:
    dMax = computeMaximumDistance(imgModel, avg)
    
    height, width = (imgInput.shape[0], imgInput.shape[1])
    result = np.zeros((height, width))
    for y in xrange(height):
        for x in xrange(width):
            dist = computeEuklidianDistance(imgInput[y, x], avg)
            if dist < dMax : result[y, x] = 1
    return result        



def aufgabe3a():
    imgModel = plt.imread('haut.png')
    imgInput = plt.imread('hand.png')
    imgBP = euklidianDistanceSearch(imgModel, imgInput)
    
    imgModelHSV = HSVTools.RGBtoHSVImage(imgModel)
    imgInputHSV = HSVTools.RGBtoHSVImage(imgInput)
    imgBP2 = euklidianDistanceSearch(imgModelHSV, imgInputHSV)
    
    plt.figure(1)
    plt.subplot(141)
    plt.imshow(imgModel)
    plt.subplot(142)
    plt.imshow(imgInput)
    plt.subplot(143)
    plt.imshow(imgBP, cmap=plt.cm.gray)
    plt.subplot(144)
    plt.imshow(imgBP2, cmap=plt.cm.gray)
    plt.show() 
   
   
   
   
' Teilaufgabe b) '  


def computeMaximumDistanceHSOnly(img, avg):
    m = 0
    for row in img :
        for px in row :
            m = max(m, computeEuklidianDistanceHSOnly(px, avg))
    return m


def computeEuklidianDistanceHSOnly(p, q):
    return math.sqrt(math.pow(p[0]-q[0], 2) + 
                      math.pow(p[1]-q[1], 2))
      
   
def euklidianDistanceSearchHSOnly(imgModel, imgInput):
    # Durchschnittsfarbwert berechnen:
    avg = computeAverageColor(imgModel)
    # maximale Distanz zu diesem Durchschnitt berechnen:
    dMax = computeMaximumDistanceHSOnly(imgModel, avg)
    
    height, width = (imgInput.shape[0], imgInput.shape[1])
    result = np.zeros((height, width))
    for y in xrange(height):
        for x in xrange(width):
            dist = computeEuklidianDistanceHSOnly(imgInput[y, x], avg)
            if dist < dMax : result[y, x] = 1
    return result    
    
    
    
def aufgabe3b():
    imgModel = plt.imread('haut.png')
    imgInput = plt.imread('hand.png')
    imgModelHSV = HSVTools.RGBtoHSVImage(imgModel)
    imgInputHSV = HSVTools.RGBtoHSVImage(imgInput)
    imgBP = euklidianDistanceSearchHSOnly(imgModelHSV, imgInputHSV)
       
    plt.figure(1)
    plt.subplot(131)
    plt.imshow(imgModel)
    plt.subplot(132)
    plt.imshow(imgInput)
    plt.subplot(133)
    plt.imshow(imgBP, cmap=plt.cm.gray)
    plt.show() 
    

'Teilaufgabe c) [Textaufgabe]'
'''
Der Vergleich der Verfahren bezueglich des Hand-Beispiels zeigt 
eine bessere "Abdeckung" der Hand beim Verfahren aus Aufgabe 3 als bei 2.
Im Vergleich von 3a zu 3b zeigt letztere Variante die Vorteile der 
Nicht-Beachtung der Helligkeitswerte im Bereich der Handflaeche. Allerdings
scheint 3a die Finger besser abzudecken.

Insgesamt finde ich in diesem Fall, dass das Verfahren aus Aufgabe 3 basierend
auf dem RGB-Farbraum das beste Ergebnis liefert. 

Generell wuerde ich aber vermuten, dass die Missachtung der Helligkeit
(also nur H,S) ueber mehrere Anwendungsfaelle hinweg betrachtet robuster ist;
z.B. auch bei Videodaten, bei denen wechselnde Lichtverhaeltnisse haeufig sind.
'''
    
        
'''
Tests:
'''
    
' Tests ausfuehren (entsprechend ein-/ausklammern): '

aufgabe3a()
#aufgabe3b()    